/**
 * SXCMPPDTS.java
 *
 * File generated from the medication::SXCMPPDTS uml Class
 * Generated by IHE - europe, gazelle team
 */
package net.ihe.gazelle.medication;

// End of user code
import java.util.List;

import javax.xml.bind.JAXBContext;
import javax.xml.bind.JAXBException;
import javax.xml.bind.Marshaller;
import javax.xml.bind.annotation.XmlAccessType;
import javax.xml.bind.annotation.XmlAccessorType;
import javax.xml.bind.annotation.XmlAttribute;
import javax.xml.bind.annotation.XmlRootElement;
import javax.xml.bind.annotation.XmlTransient;
import javax.xml.bind.annotation.XmlType;
import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;
import javax.xml.parsers.ParserConfigurationException;

import org.w3c.dom.Document;
import org.w3c.dom.Node;

import net.ihe.gazelle.gen.common.ConstraintValidatorModule;


/**
 * Description of the class SXCMPPDTS.
 *
 */

@XmlAccessorType(XmlAccessType.FIELD)
@XmlType(name = "SXCM_PPD_TS", propOrder = {
	"operator"
})
@XmlRootElement(name = "SXCM_PPD_TS")
public class SXCMPPDTS extends net.ihe.gazelle.medication.PPDTS implements java.io.Serializable {
	
	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;

	
	/**
	 *                       A code specifying whether the set
	                            component is included                      (union) or excluded
	                            (set-difference) from the set, or                      other set
	                            operations with the current set component and                      the
	                            set as constructed from the representation stream
	                            up to the current point.                   .
	 */
	@XmlAttribute(name = "operator")
	public net.ihe.gazelle.medication.SetOperator operator;
	
	/**
	 * An attribute containing marshalled element node
	 */
	@XmlTransient
	private org.w3c.dom.Node _xmlNodePresentation;
	
	
	/**
	 * Return operator.
	 * @return operator :                       A code specifying whether the set
	                            component is included                      (union) or excluded
	                            (set-difference) from the set, or                      other set
	                            operations with the current set component and                      the
	                            set as constructed from the representation stream
	                            up to the current point.                                         A code specifying whether the set
	                            component is included                      (union) or excluded
	                            (set-difference) from the set, or                      other set
	                            operations with the current set component and                      the
	                            set as constructed from the representation stream
	                            up to the current point.                                         A code specifying whether the set
	                            component is included                      (union) or excluded
	                            (set-difference) from the set, or                      other set
	                            operations with the current set component and                      the
	                            set as constructed from the representation stream
	                            up to the current point.                                         A code specifying whether the set
	                            component is included                      (union) or excluded
	                            (set-difference) from the set, or                      other set
	                            operations with the current set component and                      the
	                            set as constructed from the representation stream
	                            up to the current point.                                         A code specifying whether the set
	                            component is included                      (union) or excluded
	                            (set-difference) from the set, or                      other set
	                            operations with the current set component and                      the
	                            set as constructed from the representation stream
	                            up to the current point.                                         A code specifying whether the set
	                            component is included                      (union) or excluded
	                            (set-difference) from the set, or                      other set
	                            operations with the current set component and                      the
	                            set as constructed from the representation stream
	                            up to the current point.                                         A code specifying whether the set
	                            component is included                      (union) or excluded
	                            (set-difference) from the set, or                      other set
	                            operations with the current set component and                      the
	                            set as constructed from the representation stream
	                            up to the current point.                   
	 */
	public net.ihe.gazelle.medication.SetOperator getOperator() {
	    return operator;
	}
	
	/**
	 * Set a value to attribute operator.
	 * @param operator :                       A code specifying whether the set
	                            component is included                      (union) or excluded
	                            (set-difference) from the set, or                      other set
	                            operations with the current set component and                      the
	                            set as constructed from the representation stream
	                            up to the current point.                                         A code specifying whether the set
	                            component is included                      (union) or excluded
	                            (set-difference) from the set, or                      other set
	                            operations with the current set component and                      the
	                            set as constructed from the representation stream
	                            up to the current point.                                         A code specifying whether the set
	                            component is included                      (union) or excluded
	                            (set-difference) from the set, or                      other set
	                            operations with the current set component and                      the
	                            set as constructed from the representation stream
	                            up to the current point.                                         A code specifying whether the set
	                            component is included                      (union) or excluded
	                            (set-difference) from the set, or                      other set
	                            operations with the current set component and                      the
	                            set as constructed from the representation stream
	                            up to the current point.                                         A code specifying whether the set
	                            component is included                      (union) or excluded
	                            (set-difference) from the set, or                      other set
	                            operations with the current set component and                      the
	                            set as constructed from the representation stream
	                            up to the current point.                                         A code specifying whether the set
	                            component is included                      (union) or excluded
	                            (set-difference) from the set, or                      other set
	                            operations with the current set component and                      the
	                            set as constructed from the representation stream
	                            up to the current point.                                         A code specifying whether the set
	                            component is included                      (union) or excluded
	                            (set-difference) from the set, or                      other set
	                            operations with the current set component and                      the
	                            set as constructed from the representation stream
	                            up to the current point.                   .
	 */
	public void setOperator(net.ihe.gazelle.medication.SetOperator operator) {
	    this.operator = operator;
	}
	
	
	
	
	
	public Node get_xmlNodePresentation() {
		if (_xmlNodePresentation == null){
				JAXBContext jc;
				DocumentBuilderFactory dbf = DocumentBuilderFactory.newInstance();
				dbf.setNamespaceAware(true);
				DocumentBuilder db = null;
				Document doc = null;
				try {
					db = dbf.newDocumentBuilder();
					doc = db.newDocument();
				} catch (ParserConfigurationException e1) {}
				try {
					jc = JAXBContext.newInstance("net.ihe.gazelle.medication");
					Marshaller m = jc.createMarshaller();
					m.marshal(this, doc);
					_xmlNodePresentation = doc.getElementsByTagNameNS("urn:epsos-org:ep:medication", "SXCM_PPD_TS").item(0);
				} catch (JAXBException e) {
					try{
						db = dbf.newDocumentBuilder();
						_xmlNodePresentation = db.newDocument();
					}
					catch(Exception ee){}
				}
			}
			return _xmlNodePresentation;
	}
	
	public void set_xmlNodePresentation(Node _xmlNodePresentation) {
		this._xmlNodePresentation = _xmlNodePresentation;
	}
	
	
	

	
	/**
     * validate by a module of validation
     * 
     */
   public static void validateByModule(SXCMPPDTS sXCMPPDTS, String location, ConstraintValidatorModule cvm, List<net.ihe.gazelle.validation.Notification> diagnostic){
   		if (sXCMPPDTS != null){
   			net.ihe.gazelle.medication.PPDTS.validateByModule(sXCMPPDTS, location, cvm, diagnostic);
    	}
    }

}